# import the necessary package
from picamera.array import PiRGBArray
from picamera import PiCamera
from image_process.colorlabler import ColorLabler
from image_process.coordtransform import CoordinateTransform
from time import sleep
import argparse
import imutils
import numpy as np
import cv2
import math
import time


class DetectColor:
	#values for crop_image
    y = 130
    h = 210
    x = 140
    w = 340

    radius = 86.4	#distance between robot center and camera center in mm
    z = 239		#distance between camera and tray in mm
	#camera information
    focallength = 3.04	#mm
    pixelsize = 0.00112	#mm

    def __init__(self):
        # define the list of boundaries
        # blue (dark), red, yellow, cyan, green
        self.boundaries = [
                ([17, 15, 100], [50, 56, 200]),
                ([86, 31, 4], [220, 88, 50]),
                ([204, 204, 50], [255, 255, 102]),
                ([5, 200, 200], [125, 255, 255]),
                ([100, 192, 0], [150, 255, 150])]
	#create Matrix to save position and color
	index = np.array([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58])
	colorindex = np.full(59,-1, dtype=int)
	self.Matrix = np.column_stack((index,colorindex))
	xcoordinates = np.array([24.68,45.72,54.91,56.98,17.48,11.97,48.78,93.34,82.2,54.32,24.68,24.68,32.56,40.44,77.03,111.44,105.08,100.96,11.97,39.8,70.35,105.08,123.76,131.86,108.29,92.25,58.33,23.34,7.66,0,-24.68,-45.72,-54.91,-56.98,-17.48,-11.97,-48.78,-93.34,-82.2,-54.32,-24.68,-24.68,-32.56,-40.44,-77.03,-111.44,-105.08,-100.96,-11.97,-39.8,-70.35,-105.08,-123.76,-131.86,-108.29,-92.25,-58.33,-23.34,-7.66])
        ycoordinates = np.array([-61.88,-49.5,-24.16,19.79,59.11,-86.1,-79.83,-60.72,70.62,72.05,85.12,-106.88,-102.18,-97.47,-84.32,-39.84,-6.32,28.98,-130.68,-121.61,-110.27,-79.83,-12.15,11.8,52.11,90.76,109.74,109.74,130.48,0,61.88,49.5,24.16,-19.79,-59.11,86.1,79.83,60.72,-70.62,-72.05,-85.12,106.88,102.18,97.47,84.32,39.84,6.32,-28.98,130.68,121.61,110.27,79.83,12.15,-11.8,-52.11,-90.76,-109.74,-109.74,-130.48])
        self.Matrix = np.column_stack((self.Matrix,xcoordinates))
        self.Matrix = np.column_stack((self.Matrix,ycoordinates))

        #camera settings
	self.camera = PiCamera()
	self.camera.resolution = (640,480)
	self.rawCapture = PiRGBArray(self.camera, size=(640,480))
	#self.rawCapture = PiRGBArray(self.camera)
	time.sleep(0.1)

    def startDetection(self, angle):
        #take picture 
	self.camera.capture(self.rawCapture, format="bgr")
	image = self.rawCapture.array
        #
	#
	#angle = 90
	#if angle > 360:
        #    angle = angle - 360
	#
	#
	i = 1
        #crop the image
        crop_image = image[self.y : self.y + self.h, self.x : self.x + self.w]
	#crop_image = cv2.imread("/home/pi/Pictures/90.jpg")
	cv2.imwrite("original.png", crop_image)
	#
	#
	crop_imagehsv = cv2.cvtColor(crop_image,cv2.COLOR_BGR2HSV)
	lower_red1 = np.array([0,150,50])
	upper_red1 = np.array([10,255,255])
	lower_red2 = np.array([178,75,75])
	upper_red2 = np.array([179,255,255])
	lower_blue = np.array([110,100,100])
	upper_blue = np.array([130,255,255])
	lower_green = np.array([40,100,100])
	upper_green = np.array([70,255,255])
	lower_yellow = np.array([25,75,75])
	upper_yellow = np.array([30,255,255])
	lower_cyan = np.array([87,75,75])
	upper_cyan = np.array([91,255,255])
	#red
	mas1 = cv2.inRange(crop_imagehsv, lower_red1, upper_red1)
	cv2.imwrite("mas1.png", mas1)
	mas2 = cv2.inRange(crop_imagehsv, lower_red2, upper_red2)
	cv2.imwrite("mas2.png", mas2)
	#blue
	mas3 = cv2.inRange(crop_imagehsv, lower_blue, upper_blue)
	cv2.imwrite("mas3.png", mas3)
	#green
	mas4 = cv2.inRange(crop_imagehsv, lower_green, upper_green)
	cv2.imwrite("mas4.png", mas4)
	#yellow
	mas5 = cv2.inRange(crop_imagehsv, lower_yellow, upper_yellow)
	cv2.imwrite("mas5.png", mas5)
	#cyan
	mas6 = cv2.inRange(crop_imagehsv, lower_cyan, upper_cyan)
	cv2.imwrite("mas6.png", mas6)
	#
	mas = mas1 | mas2 | mas3 | mas4 | mas5 | mas6
	cv2.imwrite("HSV.png", mas)
	#

        # loop over the boundarie
        for (lower, upper) in self.boundaries:
            # create NumPy arrays from the boundaries
            lower = np.array(lower, dtype = "uint8")
            upper = np.array(upper, dtype = "uint8")

            # find the colors within the specified boundaries and apply
            # the mask
            mask = cv2.inRange(crop_image, lower, upper)
            if(i == 1):
                mask2 = mask | mas;
                i = 0;
            else:
                mask2 = mask2 | mask;
            outputall = cv2.bitwise_and(crop_image,crop_image,mask=mask2)

            # show the images -> Debug
            #cv2.imshow("images", outputall)
            #cv2.waitKey(0)


        # load the image, convert it to grayscale, blur it slightly,
        # and threshold it
	cv2.imwrite("MaskAll.png", outputall)
        blurred = cv2.GaussianBlur(outputall, (5, 5), 0)
        gray = cv2.cvtColor(blurred, cv2.COLOR_BGR2GRAY)
        #cv2.imwrite("Graustufenbild.png", gray)

        lab = cv2.cvtColor(blurred, cv2.COLOR_BGR2LAB)
        cv2.imwrite("lab.png", lab)
        thresh = cv2.threshold(gray, 1, 255, cv2.THRESH_BINARY)[1]

        cv2.imwrite("thresh.png", thresh)
        #cv2.waitKey(0)

        # find contours in the thresholded image
        cnts = cv2.findContours(thresh.copy(), cv2.RETR_EXTERNAL,
                cv2.CHAIN_APPROX_SIMPLE)
        cnts = cnts[0] if imutils.is_cv2() else cnts[1]
        #initialize color labeler
        cl = ColorLabler();
        tr = CoordinateTransform(self.h,self.w, self.radius, self.focallength, self.pixelsize, self.z);

        # loop over the contours
        for c in cnts:
            print("---------------------------------------")
            temp = 10000
            saveindex = -1
            # compute the center of the contour
            M = cv2.moments(c)
            cX = int((M["m10"] / M["m00"]))
            cY = int((M["m01"] / M["m00"]))
            #label color
            color_name, colorId = cl.label(lab,c)
            #transform coordinate
            xnew, ynew = tr.transform(angle,cX,cY)
            print(cX, cY)
            print(xnew, ynew,math.sqrt((xnew-self.Matrix[0][2])**2+(ynew-self.Matrix[0][3])**2))
            for j in range(59):
                    if (math.sqrt((xnew-self.Matrix[j][2])**2+(ynew-self.Matrix[j][3])**2)) < temp:
                            temp = math.sqrt((xnew-self.Matrix[j][2])**2+(ynew-self.Matrix[j][3])**2)
                            saveindex = self.Matrix[j][0]
                            print(saveindex)
            #save colorid for selected placeId
            self.Matrix[int(saveindex)][1] = colorId
            print colorId

        self.rawCapture.truncate(0)
	print self.Matrix

if __name__ == "__main__":
    ballColors = DetectColor()
    ballColors.startDetection(10)
